#include <stdlib.h>
#include <string.h>
#include "fxlib.h"
#include "explorer.h"
#include "special_chars.h"
#include "MonochromeLib.h"

#define PICTURE_SIZE    2124

int nbFichiers(void)
{
    FONTCHARACTER memory[] = {'\\','\\','f','l','s','0','\\','*','.','g','1','m',0}, nomTrouve[13] = {0};
    FILE_INFO fileInfo;
    int key, nb = 0, handle;

    if(Bfile_FindFirst(memory, &handle, nomTrouve, &fileInfo) == 0)
    {
        do {
            if(fileInfo.dsize == PICTURE_SIZE) nb++;
		}while(Bfile_FindNext(handle, nomTrouve, &fileInfo) == 0);
        Bfile_FindClose(handle);
    }
	
    if(nb == 0) {
		PopUpWin(4);
		locate(7, 3); Print("No file");
		locate(6, 5); Print("Press:[MENU]");
		while(1) GetKey(&key);
	}
	
	return nb;
}

Fichier* listerFichiers(int nb)
{
    FONTCHARACTER memory[] = {'\\','\\','f','l','s','0','\\','*','.','g','1','m',0}, nomTrouve[13] = {0};
    FILE_INFO fileInfo;
    Fichier* fichier;
    int handle, i, j = 0;
	
    fichier = malloc((nb+1)*sizeof(Fichier));
    Bfile_FindFirst(memory, &handle, nomTrouve, &fileInfo);
    do
    {
		if(fileInfo.dsize == PICTURE_SIZE) {
			for(i=0 ; nomTrouve[i] ; i++)
				fichier[j].nom[i] = nomTrouve[i];
			fichier[j].nom[i] = 0;
			fichier[j].taille = fileInfo.dsize;
			fichier[j].type = fileInfo.type;
			j++;
		}
    }while(Bfile_FindNext(handle, nomTrouve, &fileInfo) == 0);
    Bfile_FindClose(handle);
    fichier[j].nom[0] = 0;

	return fichier;
}


void explorer(char *name)
{
	Fichier* fichier;
	int key, count, top, row, pos, cur, mb, i, j, lenght;
	char line[LINE_LEN * 2 + 1];
	
	count = nbFichiers();
	fichier = listerFichiers(count);
	pos = MENU_TOP;
	top = 0;

	while(1) {
		ML_clear_vram();
		locate(COL_MIN, ROW_MIN);
		Print("Storage Memory");

		for(i = top; i < count && i - top < MENU_SIZE; i++) {
			lenght = fichier[i].taille;
			row = MENU_TOP + (i - top);
			mb = 0;

			memset(line, 0, sizeof(line));
			line[0] = ' ';
			
			for(j=0; fichier[i].nom[j]; j++)
				line[mb + j + 1] = fichier[i].nom[j];
			for(j; j<12; j++)
				line[mb + j + 1] = ' ';
			line[mb + 13] = ':';

			strncpy(line + mb + 14, "      ", 6);
			for(j=19 ; j>13 && lenght ; j--, lenght/=10)
				line[mb + j] = lenght%10 + '0';
				
			if(row == MENU_TOP && top) {
				line[mb + 20] = CHAR_MB1_ARROW_UP;
				line[mb + 21] = CHAR_MB2_ARROW_UP;
				mb++;
			} else if(row == MENU_BTM && i < count - 1) {
				line[mb + 20] = CHAR_MB1_ARROW_DOWN;
				line[mb + 21] = CHAR_MB2_ARROW_DOWN;
				mb++;
			} else line[mb + 20] = ' ';

			locate(COL_MIN, row);
			if(row == pos) PrintRev(line);
			else Print(line);
		}
		cur = top + (pos - MENU_TOP);
		GetKey(&key);
		switch(key) {
			case KEY_CTRL_UP:
				if (cur > 0) {
					if (pos > MENU_TOP)
						pos--;
					else
						top--;
				} else if (count > MENU_SIZE) {
					pos = MENU_BTM;
					top = count - MENU_SIZE;
				} else {
					pos = MENU_TOP + (count - 1);
					top = 0;
				}
				break;
			case KEY_CTRL_DOWN:
				if (cur < count - 1) {
					if (pos < MENU_BTM)
						pos++;
					else
						top++;
				} else {
					pos = MENU_TOP;
					top = 0;
				}
				break;
			case KEY_CTRL_EXE: {
				for(j=0 ; fichier[cur].nom[j] ; j++)
					name[j] = fichier[cur].nom[j];
				return;
				
				}
		}
	}
}


void nameinput(char *name)
{
	int key, i, name_length=0, cur=0;
	
	PopUpWin(5);
	locate(3, 2); Print("Save as");
	
	do {
		locate(3, 3); Print("[        ].g1m");
		locate(4, 3); Print(name);
		locate(cur+4, 3);
		GetKey(&key);
		switch(key) {
			case KEY_CTRL_DEL:
				if(cur) {
					for(i=cur-1 ; i<name_length ; i++) name[i] = name[i+1];
					cur--;
					name_length--;
				}else if(name_length) {
					for(i=0 ; i<name_length ; i++) name[i] = name[i+1];
					name_length--;
				}
				break;
			case KEY_CTRL_LEFT:
				if(cur) cur--;
				break;
			case KEY_CTRL_RIGHT:
				if(cur<name_length) cur++;
				break;
			default:
				if(name_length<8 && ((key>='A' && key<='Z') || (key>='0' && key<='9'))) {
					if(cur<name_length) {
						for(i=name_length ; i>cur ; i--)
							name[i] = name[i-1];
					}
					name[cur] = key;
					name_length++;
					cur++;
				}
		}
	} while(key!=KEY_CTRL_EXE || name_length==0);
	
	name[name_length] = '.';
	name[name_length+1] = 'g';
	name[name_length+2] = '1';
	name[name_length+3] = 'm';
	
	return;
}


int numberinput(int nb)
{
	int key, i;
	char line[9] = {0};
	line[0] = CHAR_MB1_BIG_ARROW_LEFT;
	line[1] = CHAR_MB2_BIG_ARROW_LEFT;
	line[2] = ' ';
	line[8] = '\0';
	
	do {
		i = 0;
		if(nb>9) {
			i = 1;
			line[3] = (nb/10)%10+'0';
			line[4] = nb%10+'0';
		}
		else {
			line[3] = nb + '0';
			line[7] = ' ';
		}
		line[4+i] = ' ';
		line[5+i] = CHAR_MB1_BIG_ARROW_RIGHT;
		line[6+i] = CHAR_MB2_BIG_ARROW_RIGHT;
		
		ML_clear_screen();
		PopUpWin(4);
		locate(5, 3); Print("Picture");
		locate(5, 5); Print(line);
		GetKey(&key);
		switch(key) {
			case KEY_CTRL_LEFT: {
				nb--;
				if(nb < 1) nb = 20;
				}
				break;
			case KEY_CTRL_RIGHT: {
				nb++;
				if(nb > 20) nb = 1;
				}
		}
	}while(key!=KEY_CTRL_EXE);
	return nb;
}


