/********************************************************************************************************/
/**   PictureTool by Purobaz                                                                           **/
/**   it enables to modify basic pictures as you never see                                             **/
/**                                                                                                    **/
/**   Thanks to Dafp for his searches and explanations                                                 **/
/**   and Pierrotll for his nice code                                                                  **/
/**                                                                                                    **/
/**   It's the version 2.0                                                                             **/
/**   if you want more explanations for how it works, please check out the version 1                   **/
/**   http://www.planet-casio.com/Fr/programmes/voir_un_programme_casio.php?showid=1883&page=last      **/
/**                                                                                                    **/
/********************************************************************************************************/

//ToDo
//fix the cut, copy and paste tools
//add the previous option
//improve selection box

#include "fxlib.h"
#include "explorer.h"
#include "special_chars.h"
#include "paint.h"
#include "main.h"
#include "MonochromeLib.h"

#define PICTURE_SIZE    2124


void menu(int init)
{
	ML_clear_vram();
	locate(1, 1); Print("PictureTool");
	locate(10, 8); Print("Purobaz 2014");
	locate(1, 2); Print("0) Help");
	locate(1, 3); Print("1) Open");
	if(init) {
		locate(1, 4); Print("2) Save");
		locate(1, 5); Print("3) Paint");
		locate(1, 6); Print("4) Size");
		locate(1, 7); Print("5) Number");
	}
	return;
}

void help(void)
{
	int key;
	ML_clear_vram();
	PrintMini(1,1, "PictureTool", MINI_OVER);
	PrintMini(1,10, "It enables to modify basic", MINI_OVER);
	PrintMini(1,17, "pictures", MINI_OVER);
	PrintMini(1,24, "If you want more explanations,", MINI_OVER);
	PrintMini(1,31, "please check out Picture 1024", MINI_OVER);
	PrintMini(1,38, "on Planete Casio", MINI_OVER);
	PrintMini(1,49, "Make sure your file .g1m", MINI_OVER);
	PrintMini(1,56, "contains only one picture", MINI_OVER);
	ML_display_vram();
	GetKey(&key);
	ML_clear_vram();
	PrintMini(1,1, "Paint controls :", MINI_OVER);
	PrintMini(1,8, "F1 : switch the screens", MINI_OVER);
	PrintMini(1,15, "F2 : switch the pixel colour", MINI_OVER);
	PrintMini(1,22, "F3 : selection", MINI_OVER);
	PrintMini(1,29, "F4 : cut", MINI_OVER);
	PrintMini(1,36, "F5 : copy", MINI_OVER);
	PrintMini(1,43, "F6 : paste", MINI_OVER);
	PrintMini(1,50, "SHIFT : previous", MINI_OVER);
	PrintMini(1,57, "OPTN : display the coordinates", MINI_OVER);
	ML_display_vram();
	GetKey(&key);
	return;
}


int pictopen(char *name, char *pict, char *header)
{
	int file, i;
	FONTCHARACTER filename[20] = {'\\','\\','f','l','s','0','\\'};
	
	for(i=0 ; name[i] ; i++)
		filename[7+i] = name[i];
	
	file = Bfile_OpenFile(filename, _OPENMODE_READ);
	if(file >= 0) {
		Bfile_ReadFile(file, header, 76, 0);
		Bfile_ReadFile(file, pict, PICTURE_SIZE, 92);
		Bfile_CloseFile(file);
		return 1;
	}
	return 0;
}


void write(char *name, char *pict, char *header, int size, int nb) 
{
	int file, key=1, i, j;
	FONTCHARACTER filename[20] = {'\\','\\','f','l','s','0','\\'};
	
	for(i=0 ; name[i] ; i++)
		filename[7+i] = name[i];
	
	if((file = Bfile_OpenFile(filename, _OPENMODE_READ)) >= 0) {
		Bfile_CloseFile(file);
		PopUpWin(5);
		locate(3, 2); Print(name);
		locate(3, 3); Print("Already Exists");
		locate(3, 4); Print("Overwrite OK?");
		locate(6, 5); Print("Yes:[F1]");
		locate(6, 6); Print("No :[F6]");
		while(key != KEY_CTRL_F1) {
			GetKey(&key);
			if(key == KEY_CTRL_F6) return;
		}
		Bfile_DeleteFile(filename);
	}
	
	//file size
	header[14]=(0xFF-(unsigned short)((size+141)&255))&0xFF;
	header[18]=(0xFF-(unsigned short)((size+76)>>8))&0xFF;
	header[19]=(0xFF-(unsigned short)((size+76)&255))&0xFF;
	header[20]=(0xFF-(unsigned short)((size+4)&255))&0xFF;
	//picture size
	header[71]=((unsigned short)(size>>8))&0xFF;
	header[72]=((unsigned short)(size&255))&0xFF;
	//number
	if(nb>9) {
		header[40]=(unsigned short)((nb/10)&255)|0x30;
		header[41]=(unsigned short)((nb%10)&255)|0x30;
		header[64]=(unsigned short)((nb/10)&255)|0x30;
		header[65]=(unsigned short)((nb%10)&255)|0x30;
	}
	else {
		header[40]=(unsigned short)(nb&255)|0x30;
		header[41]=0;
		header[64]=(unsigned short)(nb&255)|0x30;
		header[65]=0;
	}
	
	Bfile_CreateFile(filename, size+76);
	file = Bfile_OpenFile(filename, _OPENMODE_WRITE);
	if(file >= 0) {
		Bfile_WriteFile(file, header, 76);
		Bfile_WriteFile(file, pict, size);
		Bfile_CloseFile(file);
		PopUpWin(4);
		locate(7, 3); Print("Complete!");
		locate(6, 5); Print("Press:[EXIT]");
		while(key != KEY_CTRL_EXIT) GetKey(&key);
	}
	return;
}



int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int key, init = 0, size = 2048, nb = 1;
	char name[13] = {0}, namenew[13] = {0};
	char pict[PICTURE_SIZE] = {0};
	char header[77] = {0};
	
	while(1) {
		menu(init);
		
		GetKey(&key);
		switch(key) {
			case KEY_CHAR_0: { //help
				help();
			}
			break;
			case KEY_CHAR_1: { //open
				explorer(&name);
				init = pictopen(&name, &pict, &header);
				if((int)header[41]==0) {
					nb = (int)(header[40]&0xF);
				}
				else {
					nb = 10*(int)(header[40]&0xF)+(int)(header[41]&0xF);
				}
			}
			break;
			case KEY_CHAR_2: { //save
				if(init) {
					nameinput(&namenew);
					write(&namenew, &pict, &header, size, nb);
				}
			}
			break;
			case KEY_CHAR_3: { //paint
				if(init) {
					action(&pict);
				}
			}
			break;
			case KEY_CHAR_4: { //size
				if(init) {
					size = pictsize(&pict, size);
				}
			}
			break;
			case KEY_CHAR_5: { //number
				if(init) {
					nb = numberinput(nb);
				}
			}
		}
	}
    return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

